/* gcc version 2.7.0, HP-UX B.10.01 A 9000/819 Nov99
 - gcc -xc++ -O0 -Wall a.c # output: int=4 cplx=16 thxy=20
 Bus error (core dumped)
 - bus-error caused by attribute packed + class Complex 
 - gcc-bugs@gcc.gnu.org
 */
#include <stdlib.h>
#include <stdio.h>

class Complex
{
  double           re;
  double           im;
public:
  double           real() const;
  double           imag() const;
                   Complex();
                   Complex(const  Complex& y);
                   Complex(double r, double i=0);
                  ~Complex();
  Complex&         operator =  (const Complex& y);
};
inline double  Complex::real() const { return re; }
inline double  Complex::imag() const { return im; }
inline Complex::Complex() {}
inline Complex::Complex(const  Complex& y) :re(y.real()), im(y.imag()) {}
inline Complex::Complex(double r, double i) :re(r), im(i) {}
inline Complex::~Complex() {}
inline Complex&  Complex::operator =  (const Complex& y) { re = y.real(); im = y.imag(); return *this;} 
inline double  real(const Complex& x){ return x.real();}
inline double  imag(const Complex& x){ return x.imag();}

#define PACK __attribute__ ((packed))
struct thxy {         
 int xy;		/* 4 Byte */
 class Complex r PACK;	/* 16 Byte */
};
      
int main(){
 struct thxy tmph;
 printf("int=%d cplx=%d thxy=%d\n",sizeof(int),
  sizeof(Complex),sizeof(struct thxy));
 tmph.r=Complex(3.0,0); 
 return 0;
}

